IF EXISTS (SELECT 1 FROM sys.objects WHERE object_id = OBJECT_ID('[dbo].[order_245_query]') AND type = 'P')
DROP PROCEDURE [dbo].[order_245_query]
GO
CREATE  procedure order_245_query(
@cmpid int,@branchid int,@userdpid int,@userotid int ,@useruid int ,@bizid int ,@finished int ,@status nvarchar(50),@pagesize int , @pagecount int , @pageobjids varchar(8000),@ord_date_min datetime,@ord_date_max datetime,@ord_no_min varchar(50), @ord_no_max varchar(50),@ord_title_min nvarchar(100), @ord_title_max nvarchar(100),@ord_status_min nvarchar(30), @ord_status_max nvarchar(30),@ord_creator_min nvarchar(50), @ord_creator_max nvarchar(50)) as begin  
set nocount on  

declare @nonedate datetime 
set @nonedate = CONVERT(datetime,'1910-1-1') 
declare @s1 varchar(8000) 
declare @s2 varchar(100) 
declare @i int 
declare @amount int 
select @amount = @pagecount*@pagesize 
declare @pobjs table(nid int identity(1, 1), ordid bigint) 
set @s1 = @pageobjids 
while (@s1>'') 
begin 
set @i = charindex(',', @s1) 
if (@i>0) 
begin 
set @s2 = substring(@s1,1,@i-1) 
set @s1 = substring(@s1,@i+1,len(@s1)-@i) 
end else  
begin 
set @s2 = @s1 
set @s1 = '' 
end 
insert into @pobjs(ordid) values(convert(bigint,@s2)) 
end 
if (exists (select top 1 * from @pobjs)) 
begin 
select a.* from order_245 a, @pobjs
where ord_id=ordid
order by nid 
select a.* from order_245_users a , @pobjs 
where ordp_ordid=ordid and ordp_cuid=@useruid
return 
end 
if (@status is null or @status = '_none_') set @status = '' 



                if (@ord_date_min is null or @ord_date_min <= @nonedate) set @ord_date_min = '1900-01-01' 
                
if (@ord_date_max is null or @ord_date_max <= @nonedate) set @ord_date_max =  '2299-12-30 23:59:59'
else set @ord_date_max = @ord_date_max+ '23:59:59'
                

if (@ord_no_min is null or @ord_no_min = '_none_') set @ord_no_min = '' 
if (@ord_no_max is null or @ord_no_max = '_none_') set @ord_no_max = '' 

if (@ord_title_min is null or @ord_title_min = '_none_') set @ord_title_min = '' 
if (@ord_title_max is null or @ord_title_max = '_none_') set @ord_title_max = '' 

if (@ord_status_min is null or @ord_status_min = '_none_') set @ord_status_min = '' 
if (@ord_status_max is null or @ord_status_max = '_none_') set @ord_status_max = '' 

if (@ord_creator_min is null or @ord_creator_min = '_none_') set @ord_creator_min = '' 
if (@ord_creator_max is null or @ord_creator_max = '_none_') set @ord_creator_max = '' 

if @ord_no_min>'' 
begin 
if (charindex('%',@ord_no_min) = 0 and @ord_no_min!='_empty_') 
 begin
set @ord_no_min = '%'+@ord_no_min+'%';
 end else if (@ord_no_min='_empty_') set @ord_no_min='' 
end else
begin 
set @ord_no_min = '%' 
end
if @ord_no_max>'' 
begin 
if (charindex('%', @ord_no_max) = 0 and @ord_no_max!='_empty_') 
begin
set@ord_no_max = '%'+@ord_no_max+'%';
 end else if (@ord_no_max='_empty_') set @ord_no_max='' 
end else
begin 
set @ord_no_max = '%' 
end

if @ord_title_min>'' 
begin 
if (charindex('%',@ord_title_min) = 0 and @ord_title_min!='_empty_') 
 begin
set @ord_title_min = '%'+@ord_title_min+'%';
 end else if (@ord_title_min='_empty_') set @ord_title_min='' 
end else
begin 
set @ord_title_min = '%' 
end
if @ord_title_max>'' 
begin 
if (charindex('%', @ord_title_max) = 0 and @ord_title_max!='_empty_') 
begin
set@ord_title_max = '%'+@ord_title_max+'%';
 end else if (@ord_title_max='_empty_') set @ord_title_max='' 
end else
begin 
set @ord_title_max = '%' 
end

if @ord_status_min>'' 
begin 
if (charindex('%',@ord_status_min) = 0 and @ord_status_min!='_empty_') 
 begin
set @ord_status_min = '%'+@ord_status_min+'%';
 end else if (@ord_status_min='_empty_') set @ord_status_min='' 
end else
begin 
set @ord_status_min = '%' 
end
if @ord_status_max>'' 
begin 
if (charindex('%', @ord_status_max) = 0 and @ord_status_max!='_empty_') 
begin
set@ord_status_max = '%'+@ord_status_max+'%';
 end else if (@ord_status_max='_empty_') set @ord_status_max='' 
end else
begin 
set @ord_status_max = '%' 
end

if @ord_creator_min>'' 
begin 
if (charindex('%',@ord_creator_min) = 0 and @ord_creator_min!='_empty_') 
 begin
set @ord_creator_min = '%'+@ord_creator_min+'%';
 end else if (@ord_creator_min='_empty_') set @ord_creator_min='' 
end else
begin 
set @ord_creator_min = '%' 
end
if @ord_creator_max>'' 
begin 
if (charindex('%', @ord_creator_max) = 0 and @ord_creator_max!='_empty_') 
begin
set@ord_creator_max = '%'+@ord_creator_max+'%';
 end else if (@ord_creator_max='_empty_') set @ord_creator_max='' 
end else
begin 
set @ord_creator_max = '%' 
end
 
    
if (@finished = -11)
begin
if (@pagesize=10000)  -- 下载
begin
select a.* from order_245 a,order_245_users 
where a.ord_cmpid=@cmpid 
and ordp_ordid=a.ord_id 
and ordp_type='bizview' 
and ordp_cuid=@useruid 
and (a.ord_status=@status or @status='') 
and a.ord_finished > 0 
and ord_date>=@ord_date_min 
and ord_date<=@ord_date_max 
and ord_no like @ord_no_min 
and ord_no like @ord_no_max 
and ord_title like @ord_title_min 
and ord_title like @ord_title_max 
and ord_status like @ord_status_min 
and ord_status like @ord_status_max 
and ord_creator like @ord_creator_min 
and ord_creator like @ord_creator_max 
order by ord_date desc,ord_no,ord_title,ord_status,ord_creator
end else 
if (@pagesize>=100000000)  --  转存到中间表
begin
set @pagesize = @pagesize - 100000000 
if (@pagesize<=0) set @pagesize = 100000000 
delete datalinker where useruid = @useruid 
insert into datalinker(useruid,objid) 
select top(@pagesize) @useruid,a.ord_id  from order_245 a,order_245_users 
where a.ord_id=ordp_ordid 
and ordp_type='bizview' 
and ordp_cuid=@useruid 
and a.ord_finished > 0
and (a.ord_status=@status or @status='') 
and ord_date>=@ord_date_min 
and ord_date<=@ord_date_max 
and ord_no like @ord_no_min 
and ord_no like @ord_no_max 
and ord_title like @ord_title_min 
and ord_title like @ord_title_max 
and ord_status like @ord_status_min 
and ord_status like @ord_status_max 
and ord_creator like @ord_creator_min 
and ord_creator like @ord_creator_max 
order by ord_date desc,ord_no,ord_title,ord_status,ord_creator
select count(1) resultcount  from datalinker where useruid=@useruid 
end else
begin
select count(1) cnt from order_245 a,order_245_users 
where a.ord_id=ordp_ordid 
and a.ord_finished > 0
and ordp_type='bizview' 
and ordp_cuid=@useruid 
and (a.ord_status=@status or @status='') 
and ord_date>=@ord_date_min 
and ord_date<=@ord_date_max 
and ord_no like @ord_no_min 
and ord_no like @ord_no_max 
and ord_title like @ord_title_min 
and ord_title like @ord_title_max 
and ord_status like @ord_status_min 
and ord_status like @ord_status_max 
and ord_creator like @ord_creator_min 
and ord_creator like @ord_creator_max 

-- 返回所有ID
insert into @pobjs(ordid) select top(@amount) ord_id from order_245 a,order_245_users 
where a.ord_id=ordp_ordid 
and a.ord_finished > 0
and ordp_type='bizview' 
and ordp_cuid=@useruid 
and (a.ord_status=@status or @status='') 
and ord_date>=@ord_date_min 
and ord_date<=@ord_date_max 
and ord_no like @ord_no_min 
and ord_no like @ord_no_max 
and ord_title like @ord_title_min 
and ord_title like @ord_title_max 
and ord_status like @ord_status_min 
and ord_status like @ord_status_max 
and ord_creator like @ord_creator_min 
and ord_creator like @ord_creator_max 
order by ord_date desc,ord_no,ord_title,ord_status,ord_creator
select ordid from @pobjs 
order by nid 
-- 返回第一页 
select top(@pagesize) a.* from order_245 a,@pobjs 
where a.ord_id=ordid 
and (a.ord_status=@status or @status='')
and a.ord_finished > 0
order by nid 
-- 返回权限 
select a.* from order_245_users a , @pobjs 
where ordp_ordid=ordid 
and nid<=@pagesize 
and ordp_cuid=@useruid 
end 
end else
if (@finished = -10)
begin
if (@pagesize=10000)  -- 下载
begin
select a.* from order_245 a,order_245_users 
where a.ord_cmpid=@cmpid 
and ordp_type='bizview' 
and ordp_ordid=a.ord_id 
and ordp_cuid=@useruid 
and (a.ord_status=@status or @status='') 
and (a.ord_finished>0 and a.ord_createcuid=@useruid) 
and ord_date>=@ord_date_min 
and ord_date<=@ord_date_max 
and ord_no like @ord_no_min 
and ord_no like @ord_no_max 
and ord_title like @ord_title_min 
and ord_title like @ord_title_max 
and ord_status like @ord_status_min 
and ord_status like @ord_status_max 
and ord_creator like @ord_creator_min 
and ord_creator like @ord_creator_max 
order by ord_date desc,ord_no,ord_title,ord_status,ord_creator
end else 
if (@pagesize>=100000000)  --  转存到中间表
begin
set @pagesize = @pagesize - 100000000 
if (@pagesize<=0) set @pagesize = 100000000 
delete datalinker where useruid = @useruid 
insert into datalinker(useruid,objid) 
select top(@pagesize) @useruid,a.ord_id  from order_245 a,order_245_users 
where a.ord_id=ordp_ordid 
and ordp_type='bizview' 
and ordp_cuid=@useruid 
and (a.ord_finished>0 and a.ord_createcuid=@useruid) 
and (a.ord_status=@status or @status='') 
and ord_date>=@ord_date_min 
and ord_date<=@ord_date_max 
and ord_no like @ord_no_min 
and ord_no like @ord_no_max 
and ord_title like @ord_title_min 
and ord_title like @ord_title_max 
and ord_status like @ord_status_min 
and ord_status like @ord_status_max 
and ord_creator like @ord_creator_min 
and ord_creator like @ord_creator_max 
order by ord_date desc,ord_no,ord_title,ord_status,ord_creator
select count(1) resultcount  from datalinker where useruid=@useruid 
end else
begin
select count(1) cnt from order_245 a,order_245_users 
where a.ord_id=ordp_ordid 
and (a.ord_finished>0 and a.ord_createcuid=@useruid) 
and ordp_type='bizview' 
and ordp_cuid=@useruid 
and (a.ord_status=@status or @status='') 
and ord_date>=@ord_date_min 
and ord_date<=@ord_date_max 
and ord_no like @ord_no_min 
and ord_no like @ord_no_max 
and ord_title like @ord_title_min 
and ord_title like @ord_title_max 
and ord_status like @ord_status_min 
and ord_status like @ord_status_max 
and ord_creator like @ord_creator_min 
and ord_creator like @ord_creator_max 

-- 返回所有ID
insert into @pobjs(ordid) select top(@amount) ord_id from order_245 a,order_245_users 
where a.ord_id=ordp_ordid 
and (a.ord_finished>0 and a.ord_createcuid=@useruid) 
and ordp_type='bizview' 
and ordp_cuid=@useruid 
and (a.ord_status=@status or @status='') 
and ord_date>=@ord_date_min 
and ord_date<=@ord_date_max 
and ord_no like @ord_no_min 
and ord_no like @ord_no_max 
and ord_title like @ord_title_min 
and ord_title like @ord_title_max 
and ord_status like @ord_status_min 
and ord_status like @ord_status_max 
and ord_creator like @ord_creator_min 
and ord_creator like @ord_creator_max 
order by ord_date desc,ord_no,ord_title,ord_status,ord_creator
select ordid from @pobjs 
order by nid 
-- 返回第一页 
select top(@pagesize) a.* from order_245 a,@pobjs 
where a.ord_id=ordid 
and (a.ord_status=@status or @status='')
and (a.ord_finished>0 and a.ord_createcuid=@useruid) 
order by nid 
-- 返回权限 
select a.* from order_245_users a , @pobjs 
where ordp_ordid=ordid 
and nid<=@pagesize 
and ordp_cuid=@useruid 
end 
end else
if (@finished = 2)
begin
if (@pagesize=10000)  -- 下载
begin
select a.* from order_245 a,order_245_users 
where a.ord_cmpid=@cmpid 
and ordp_ordid=a.ord_id 
and ordp_type='bizview' 
and ordp_cuid=@useruid 
and (a.ord_status=@status or @status='') 
and a.ord_finished>=2 
and ord_date>=@ord_date_min 
and ord_date<=@ord_date_max 
and ord_no like @ord_no_min 
and ord_no like @ord_no_max 
and ord_title like @ord_title_min 
and ord_title like @ord_title_max 
and ord_status like @ord_status_min 
and ord_status like @ord_status_max 
and ord_creator like @ord_creator_min 
and ord_creator like @ord_creator_max 
order by ord_date desc,ord_no,ord_title,ord_status,ord_creator
end else 
if (@pagesize>=100000000)  --  转存到中间表
begin
set @pagesize = @pagesize - 100000000 
if (@pagesize<=0) set @pagesize = 100000000 
delete datalinker where useruid = @useruid 
insert into datalinker(useruid,objid) 
select top(@pagesize) @useruid,a.ord_id  from order_245 a,order_245_users 
where a.ord_id=ordp_ordid 
and ordp_type='bizview' 
and ordp_cuid=@useruid 
and a.ord_finished>=2 
and (a.ord_status=@status or @status='') 
and ord_date>=@ord_date_min 
and ord_date<=@ord_date_max 
and ord_no like @ord_no_min 
and ord_no like @ord_no_max 
and ord_title like @ord_title_min 
and ord_title like @ord_title_max 
and ord_status like @ord_status_min 
and ord_status like @ord_status_max 
and ord_creator like @ord_creator_min 
and ord_creator like @ord_creator_max 
order by ord_date desc,ord_no,ord_title,ord_status,ord_creator
select count(1) resultcount  from datalinker where useruid=@useruid 
end else
begin
select count(1) cnt from order_245 a,order_245_users 
where a.ord_id=ordp_ordid 
and a.ord_finished>=2 
and ordp_type='bizview' 
and ordp_cuid=@useruid 
and (a.ord_status=@status or @status='') 
and ord_date>=@ord_date_min 
and ord_date<=@ord_date_max 
and ord_no like @ord_no_min 
and ord_no like @ord_no_max 
and ord_title like @ord_title_min 
and ord_title like @ord_title_max 
and ord_status like @ord_status_min 
and ord_status like @ord_status_max 
and ord_creator like @ord_creator_min 
and ord_creator like @ord_creator_max 

-- 返回所有ID
insert into @pobjs(ordid) select top(@amount) ord_id from order_245 a,order_245_users 
where a.ord_id=ordp_ordid 
and a.ord_finished>=2 
and ordp_type='bizview' 
and ordp_cuid=@useruid 
and (a.ord_status=@status or @status='') 
and ord_date>=@ord_date_min 
and ord_date<=@ord_date_max 
and ord_no like @ord_no_min 
and ord_no like @ord_no_max 
and ord_title like @ord_title_min 
and ord_title like @ord_title_max 
and ord_status like @ord_status_min 
and ord_status like @ord_status_max 
and ord_creator like @ord_creator_min 
and ord_creator like @ord_creator_max 
order by ord_date desc,ord_no,ord_title,ord_status,ord_creator
select ordid from @pobjs 
order by nid 
-- 返回第一页 
select top(@pagesize) a.* from order_245 a,@pobjs 
where a.ord_id=ordid 
and (a.ord_status=@status or @status='')
and a.ord_finished>=2 
order by nid 
-- 返回权限 
select a.* from order_245_users a , @pobjs 
where ordp_ordid=ordid 
and nid<=@pagesize 
and ordp_cuid=@useruid 
end 
end else
if (@finished = 1)
begin
if (@pagesize=10000)  -- 下载
begin
select a.* from order_245 a,order_245_users 
where a.ord_cmpid=@cmpid 
and ordp_type='bizview' 
and ordp_cuid=@useruid 
and ordp_ordid=a.ord_id 
and (a.ord_status=@status or @status='') 
and (a.ord_finished>0 and a.ord_finished<=1)
and ord_date>=@ord_date_min 
and ord_date<=@ord_date_max 
and ord_no like @ord_no_min 
and ord_no like @ord_no_max 
and ord_title like @ord_title_min 
and ord_title like @ord_title_max 
and ord_status like @ord_status_min 
and ord_status like @ord_status_max 
and ord_creator like @ord_creator_min 
and ord_creator like @ord_creator_max 
order by ord_date desc,ord_no,ord_title,ord_status,ord_creator
end else 
if (@pagesize>=100000000)  --  转存到中间表
begin
set @pagesize = @pagesize - 100000000 
if (@pagesize<=0) set @pagesize = 100000000 
delete datalinker where useruid = @useruid 
insert into datalinker(useruid,objid) 
select top(@pagesize) @useruid,a.ord_id  from order_245 a,order_245_users 
where a.ord_id=ordp_ordid 
and ordp_type='bizview' 
and ordp_cuid=@useruid 
and (a.ord_finished>0 and a.ord_finished<=1)
and (a.ord_status=@status or @status='') 
and ord_date>=@ord_date_min 
and ord_date<=@ord_date_max 
and ord_no like @ord_no_min 
and ord_no like @ord_no_max 
and ord_title like @ord_title_min 
and ord_title like @ord_title_max 
and ord_status like @ord_status_min 
and ord_status like @ord_status_max 
and ord_creator like @ord_creator_min 
and ord_creator like @ord_creator_max 
order by ord_date desc,ord_no,ord_title,ord_status,ord_creator
select count(1) resultcount  from datalinker where useruid=@useruid 
end else
begin
select count(1) cnt from order_245 a,order_245_users 
where a.ord_id=ordp_ordid 
and (a.ord_finished>0 and a.ord_finished<=1)
and ordp_type='bizview' 
and ordp_cuid=@useruid 
and (a.ord_status=@status or @status='') 
and ord_date>=@ord_date_min 
and ord_date<=@ord_date_max 
and ord_no like @ord_no_min 
and ord_no like @ord_no_max 
and ord_title like @ord_title_min 
and ord_title like @ord_title_max 
and ord_status like @ord_status_min 
and ord_status like @ord_status_max 
and ord_creator like @ord_creator_min 
and ord_creator like @ord_creator_max 

-- 返回所有ID
insert into @pobjs(ordid) select top(@amount) ord_id from order_245 a,order_245_users 
where a.ord_id=ordp_ordid 
and (a.ord_finished>0 and a.ord_finished<=1)
and ordp_type='bizview' 
and ordp_cuid=@useruid 
and (a.ord_status=@status or @status='') 
and ord_date>=@ord_date_min 
and ord_date<=@ord_date_max 
and ord_no like @ord_no_min 
and ord_no like @ord_no_max 
and ord_title like @ord_title_min 
and ord_title like @ord_title_max 
and ord_status like @ord_status_min 
and ord_status like @ord_status_max 
and ord_creator like @ord_creator_min 
and ord_creator like @ord_creator_max 
order by ord_date desc,ord_no,ord_title,ord_status,ord_creator
select ordid from @pobjs 
order by nid 
-- 返回第一页 
select top(@pagesize) a.* from order_245 a,@pobjs 
where a.ord_id=ordid 
and (a.ord_status=@status or @status='')
and (a.ord_finished>0 and a.ord_finished<=1) 
order by nid 
-- 返回权限 
select a.* from order_245_users a , @pobjs 
where ordp_ordid=ordid 
and nid<=@pagesize 
and ordp_cuid=@useruid 
end 
end else
if (@finished = -1)
begin
if (@pagesize=10000)  -- 下载
begin
select a.* from order_245 a,order_245_users 
where a.ord_cmpid=@cmpid 
and ordp_type='bizview' 
and ordp_ordid=a.ord_id 
and ordp_cuid=@useruid 
and (a.ord_status=@status or @status='') 
and ord_finished=-1 
and ord_date>=@ord_date_min 
and ord_date<=@ord_date_max 
and ord_no like @ord_no_min 
and ord_no like @ord_no_max 
and ord_title like @ord_title_min 
and ord_title like @ord_title_max 
and ord_status like @ord_status_min 
and ord_status like @ord_status_max 
and ord_creator like @ord_creator_min 
and ord_creator like @ord_creator_max 
order by ord_date desc,ord_no,ord_title,ord_status,ord_creator
end else 
if (@pagesize>=100000000)  --  转存到中间表
begin
set @pagesize = @pagesize - 100000000 
if (@pagesize<=0) set @pagesize = 100000000 
delete datalinker where useruid = @useruid 
insert into datalinker(useruid,objid) 
select top(@pagesize) @useruid,a.ord_id  from order_245 a,order_245_users 
where a.ord_id=ordp_ordid 
and ordp_type='bizview' 
and ordp_cuid=@useruid 
and ord_finished=-1 
and (a.ord_status=@status or @status='') 
and ord_date>=@ord_date_min 
and ord_date<=@ord_date_max 
and ord_no like @ord_no_min 
and ord_no like @ord_no_max 
and ord_title like @ord_title_min 
and ord_title like @ord_title_max 
and ord_status like @ord_status_min 
and ord_status like @ord_status_max 
and ord_creator like @ord_creator_min 
and ord_creator like @ord_creator_max 
order by ord_date desc,ord_no,ord_title,ord_status,ord_creator
select count(1) resultcount  from datalinker where useruid=@useruid 
end else
begin
select count(1) cnt from order_245 a,order_245_users 
where a.ord_id=ordp_ordid 
and ord_finished=-1 
and ordp_type='bizview' 
and ordp_cuid=@useruid 
and (a.ord_status=@status or @status='') 
and ord_date>=@ord_date_min 
and ord_date<=@ord_date_max 
and ord_no like @ord_no_min 
and ord_no like @ord_no_max 
and ord_title like @ord_title_min 
and ord_title like @ord_title_max 
and ord_status like @ord_status_min 
and ord_status like @ord_status_max 
and ord_creator like @ord_creator_min 
and ord_creator like @ord_creator_max 

-- 返回所有ID
insert into @pobjs(ordid) select top(@amount) ord_id from order_245 a,order_245_users 
where a.ord_id=ordp_ordid 
and ord_finished=-1 
and ordp_type='bizview' 
and ordp_cuid=@useruid 
and (a.ord_status=@status or @status='') 
and ord_date>=@ord_date_min 
and ord_date<=@ord_date_max 
and ord_no like @ord_no_min 
and ord_no like @ord_no_max 
and ord_title like @ord_title_min 
and ord_title like @ord_title_max 
and ord_status like @ord_status_min 
and ord_status like @ord_status_max 
and ord_creator like @ord_creator_min 
and ord_creator like @ord_creator_max 
order by ord_date desc,ord_no,ord_title,ord_status,ord_creator
select ordid from @pobjs 
order by nid 
-- 返回第一页 
select top(@pagesize) a.* from order_245 a,@pobjs 
where a.ord_id=ordid 
and (a.ord_status=@status or @status='')
and ord_finished=-1 
order by nid 
-- 返回权限 
select a.* from order_245_users a , @pobjs 
where ordp_ordid=ordid 
and nid<=@pagesize 
and ordp_cuid=@useruid 
end 
end 
set nocount off end